#include <bits/stdc++.h>
#define int long long
using namespace std;
int n,k,t;
vector<int>a;
signed main()
{
cin>>t>>n>>k;
a.resize(n);
for(int i = 0;i<n;i++)
cin>>a[i];
bool isti=true,jed=true,ai=true;
for(int i = 0;i<n;i++)
if(a[i]!=i+1)
ai=false;
for(int i = 1;i<n;i++)
if(a[i]!=a[i-1])
isti=false;
for(int i = 1;i<n;i++)
if(a[i]!=1&&a[i]!=-1)
jed=false;
if((n-k)%2==0)
if(jed){
if(k>2||k<-1)
cout<<"NE"<<endl;
else{
int cntpl=0,cntmi;
for(int i = 0;i<n;i++)
if(a[i]==1)
cntpl++;
cntmi=n-cntpl;


}




}
else if(isti){
int curr=0;
for(int i = 0;i<n;i++){
if(curr<=a[0])
curr++;
else
curr--;
}
if(curr==k){
cout<<"DA"<<endl;
if(t==1)
for(int i = 0;i<n;i++)
cout<<a[i]<<" ";
cout<<endl;
}
else
cout<<"NE"<<endl;
}
else if(ai){
if(k<0)
cout<<"NE"<<endl;
else{
int x=(n-k)/2;
int poz=k+x;
int neg=x;
if(poz>=neg){
if(x+1>=1){
cout<<"DA"<<endl;
if(t==1){
for(int i = x+1;i<=n;i++)
cout<<i<<" ";
for(int i = 1;i<=x;i++)
cout<<i<<" ";
cout<<endl;

}

}
else
cout<<"NE"<<endl;
}
else
cout<<"NE"<<endl;


}





}
else{
sort(a.begin(),a.end());
int curr=0;
for(int i = 0;i<n;i++){
if(curr<=a[i])
curr++;
else
curr--;
}
if(curr==k){
cout<<"DA"<<endl;
if(t==1)
for(int i = 0;i<n;i++)
cout<<a[i]<<" ";
cout<<endl;
}
else
cout<<"NE"<<endl;
}





if((n-k)%2==1)
cout<<"NE"<<endl;



    return 0;
}